/* Copyright (c) 2020-2024 Gregor Haefner

   This file is part of UDM.

   UDM is free software: you can redistribute it and/or modify
   it under the terms of the GNU Lesser General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   UDM is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public License
   along with UDM.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef RANDOM_H
#define RANDOM_H

#include "phase.h"

typedef struct PCG_STATE
{
    uint64_t state;
    uint64_t inc;
} PCG_STATE;

/*---Function Declarations: -------------------------------------------------------------------------------------------------------------------------------------*/
/** Initialize the cuRAND states at start of simulation.
 *
 * \param p Pointer to fully intitialized simulation structure (PHASE).
 */
void init_random_states(PHASE *p);

/** Add the thermal noise contribution to the explicit increment, last term of eq. (11), 
 * generated by eq. (22) of model_introduction.pdf.
 *
 * \param p Pointer to fully intitialized simulation structure (PHASE).
 */
void add_thermal_noise(PHASE *p);

#endif //RANDOM_H
